

/* turbo.h */

#ifndef TURBO_H
#define TURBO_H

/* the following are the possible turbo server response codes */

#define TURBO_COMPLETION	0x01	/* returned after search or repeat */
#define TURBO_COMMAND_ERROR	0x02	/* command invalid or too large */
#define TURBO_REQ_FAILED	0x03	/* command failed -- not supported */
#define TURBO_PGMEND		0x04	/* completed internal program */

#define TURBO_ACK		0x0a	/* 1-byte command understood */
#define TURBO_NAK		0x0b	/* 1-byte command not understood */

/* the rest are possible command bytes */

#define TURBO_OPEN_SERVER	0x01
#define TURBO_RESET		0x02
#define TURBO_VOLUME_TABLE	0x03

#define TURBO_SEARCH		0x04
#define TURBO_VARSPEED		0x05
#define TURBO_DOWNLOAD		0x06
#define TURBO_PLAYLIST		0x07
#define TURBO_CONFIGURE		0x08
#define TURBO_GETFRAME		0x09
#define TURBO_RESERVE		0x0a
#define TURBO_JOG		0x0b

#endif TURBO_H
